unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure fixstring(w : byte;var s : string);
begin
 while length(s) < w do insert(' ',s,1);
end;

procedure report(f : dword; c : byte);
//report c factors f  in memo1
var s,s1 : string;
begin
 with form1.memo1 do
  begin
   s := inttostr(f);
   fixstring(8,s);
   s1 := inttostr(c);
   fixstring(6,s1);
   s := s + s1;
   lines.add(s);
  end;
end;

procedure factorize(N : dword);
var N1 : dword;
    count : byte;
    factor,m : word;
    fplus : byte;
    XF : boolean;
begin
 factor := 2;
 fplus := 2;
 repeat
  count := 0;
  repeat
   m := N mod factor;
   N1 := N div factor;
   XF := N1 <= factor;
   if m = 0 then
    begin
     N := N1;
     inc(count);
    end;
  until m > 0;
  if count > 0 then report(factor,count);
  if factor < 5 then factor := (factor shl 1) - 1
   else begin
         factor := factor + fplus;
         fplus := 6 - fplus;
        end;
 until XF;
 if N > 1 then report(N,1);
end;

function GCD(A,B : dword) : dword;
var H : dword;
begin
 while A > 0 do
  begin
   if A < B then begin
                  H := A;
                  A := B;
                  B := H;
                 end;
   A := A mod B;
  end;
 result := B;
end;

procedure TForm1.Button1Click(Sender: TObject);
//factorize/GCD  button
var D,N1,N2 : dword;
begin
 memo1.clear;
 with edit1 do
  if length(text)>0 then N1 := strtoint(text) else N1 := 0;
 with edit2 do
  if length(text)>0 then N2 := strtoint(text) else N2 := 0;
//
 if N1>0 then
  begin
   memo1.Lines.add('N1 = '+edit1.Text);
   memo1.Lines.Add('factors'+'    count');
   factorize(N1);
   memo1.Lines.Add(' ');
  end;
//
 if N2>0 then
  begin
   memo1.Lines.add('N2 = '+edit2.Text);
   memo1.Lines.Add('factors'+'    count');
   factorize(N2);
   memo1.lines.add(' ');
  end;
//
 if (N1>1) and (N2>1) then
 begin
  D := GCD(N1,N2);
  if D=1 then memo1.Lines.Add('no common factors')
   else begin
         memo1.lines.add('GCD('+ edit1.text + ',' + edit2.text+')');
         memo1.Lines.Add(inttostr(D));
        end;
 end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var mt,OK : boolean;
begin
 mt := length(edit1.Text) > 0;
 case key of
  '0' : OK := mt;
  '1'..'9' : OK := true;
  #8  : OK := true;
  else OK := false;
 end;
 if OK = false then key := #0;
end;

end.
